/*---------------------------------------------------------------------------

  Auteur : panurge (panurge@taroteam.com)
  Version : 0.1 (12 fvrier 2002)
  Remarque : Exemple d'IA pour WebTarot utilisant l'API adquate.
             vous allez voir, elle est vraiment bte, cette IA !!!

---------------------------------------------------------------------------*/


#include <windows.h> // ncessaire pour DllEntryPoint (c'est une DLL !)
#include <string> // on va utiliser des string dans notre exemple (la rfrence n'est pas obligatoire en elle-mme)
#include "dummydll.h" // contient la dclaration des fonctions exportes


#pragma argsused

int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
   if (reason==DLL_PROCESS_ATTACH)
   {
   // intialisation de la DLL (n'intervient qu'une fois, lors du chargement de la DLL)
      randomize;
   }
        return 1;
}
//---------------------------------------------------------------------------


using namespace std;

// les types destins  la sauvegarde des mains des joueurs
// (dans cet exemple simple on utilise vulgairement un "string" mais libre  vous de concevoir un bel objet,
// aprs tout nous sommes en C++ !!!)

typedef string t_main;
typedef struct
    {
          t_main main; // dans cet exemple simple, un joueur n'est dfini que par sa main
    }   t_joueur;

 // valeur des contrats
const passe=0;
const petite=1;
const garde=2;
const gardeS=3;
const gardeC=4;

// constantes relatives aux valeurs numriques des cartes
// couleurs et atouts
const coeur=1;
const pique=2;
const carreau=3;
const trefle=4;
const atout=5;

// valeur des ttes
const val=11;
const cav=12;
const dam=13;
const roi=14;

// l'excuse est la dernire des 78 cartes !
const excuse=78;

// on se dclare une paire de variables pour ne pas perdre la mmoire :)
// libre  vous de stocker comme vous le voulez les mains, plis et autres valeurs (le stockage ici implment n'est qu'un exemple)
int NbJ; // on va stocker le nombre de joueurs
t_joueur j[5]; // sauvegarde de la main actuelle de chacun des joueurs
t_main chien; // sauvegarde du chien
t_main ecart; // sauvegarde de l'cart
byte preneur; // numro (1..5) du preneur
byte contrat; // contrat (passe..gardeC) du preneur
t_peutjouer px; // pointeur vers la fonction "peutjouer" de WebTarot (utilisable pour vrifier le respect des rgles du tarot)

byte pli[5]; // pli en cours (pli[1] correspond ici  la carte joue par le joueur 1)
int maitre; // numro (1..5) du joueur maitre du pli
int entame; // numro (1..5) du joueur entamant le pli


// *****************************************************************************
// ******* Fonctions destines  nous simplifier la vie dans cet exemple *******

// renvoit le n de la carte (1..78)
byte carte2byte(byte couleur,byte hauteur)
{
  return (couleur-1)*14+hauteur;
}

// renvoit la couleur (coeur..atout) de la carte "carte"
byte couleur(byte carte)
{
   return (carte>4*14 ? atout : div(carte-1,14).quot+1);
}

// renvoit la hauteur (1..roi ou 1..excuse) de la carte "carte"
byte hauteur(byte carte)
{
  return (carte>4*14 ? carte-4*14 : (carte-1)%14+1);
}

// enlve une carte d'une main
t_main retire(t_main bob,byte carte)
{
  t_main xx="";
  t_main zo=bob;
  for (int cnt=0; cnt<zo.size();cnt++) if (zo[cnt]!=carte) xx+=zo[cnt];
  return xx;
}

// renvoit true si la carte fait partie de la main (sinon : false)
bool comprend(t_main bob,byte carte)
{
  t_main zo=bob;
  for (int cnt=0; cnt<zo.size();cnt++) if (zo[cnt]==carte) return true;
  return false;
}

// *****************************************************************************








// *****************************************************************************
// ******************** Fonctions appeles par WebTarot ************************



// procdure appele en dbut de partie
// paramtres : nbjoueurs = nombre de joueurs  la partie (3..5)
//              pointeur_peutjouer = pointeur vers la fonction de WebTarot "peutjouer"
void _stdcall Debut_Partie(int nbjoueurs, t_peutjouer pointeur_peutjouer)
{
     // rcupre le pointeur vers la fonction de WebTarot "peutjouer"
     px=pointeur_peutjouer;
     // fixe le nombre de joueurs
     NbJ=nbjoueurs;
     ecart="";
}

//---------------------------------------------------------------------------
// procdure appele  chaque dbut de pli
// paramtres : numpli = numro du pli en cours (1..24)
//              entameur = numro (1..5) du joueur charg d'entamer le pli
void _stdcall Debut_Pli(int numpli, int entameur)
{
  // mise  zro du pli, du joueur matre et fixe l'entame
  for (int cnt=1; cnt<=5; cnt++) pli[cnt]=0;
  maitre=0;
  entame=entameur;
}

//---------------------------------------------------------------------------
// procdure appele  chaque fin de pli
// paramtres : nump = numro (1..24) du pli qui vient de s'achever
void _stdcall Fin_Pli(int nump)
{
}

//---------------------------------------------------------------------------
// procdure appele lors de la distribution (elle est appele nbjoueurs+1 fois)
// paramtres : joueur = numro du joueur dont on communique la main (1..5 pour joueur 1..5 et 0 pour le chien)
//              cartes = chane dont la valeur numrique de chaque caractre correspond  une carte (ex : byte('A')=65)

void _stdcall Recoit_Distribution(int joueur, char * cartes)
{
     if (joueur==0) chien=cartes; else j[joueur].main=cartes;
}

//---------------------------------------------------------------------------
// procdure appele  chaque fois qu'un joueur "joueur" a fait une enchre "lecontrat"
// paramtres : joueur = numro du joueur en question (1..5)
//              lecontrat = contrat pris par ce joueur (passe..gardec)
void _stdcall Recoit_Enchere(int joueur, int lecontrat)
{
     // si le joueur en question passe, a ne nous intresse pas
     if (lecontrat>passe)
     {
          // le preneur (provisoire) et son contrat sont sauvegards
        contrat=lecontrat;
        preneur=joueur;
     }
}

//---------------------------------------------------------------------------
// fonction renvoyant l'enchre conseille pour le joueur
// paramtres : joueur = numro du joueur en question
//              maxic  = plus haut contrat pris jusqu' prsent
int _stdcall Envoie_Enchere(int joueur, int maxic)
{
      //  MessageBox(0,j[joueur].main.begin(),"total",0);
        byte tmpcontrat;
        tmpcontrat=passe;
        if (comprend(j[joueur].main,carte2byte(atout,1))) tmpcontrat++;
        if (comprend(j[joueur].main,carte2byte(atout,21))) tmpcontrat++;
        if (comprend(j[joueur].main,excuse)) tmpcontrat++;
//        if (strchr(j[joueur].main,carte2byte(atout,1))!=NULL ) tmpcontrat++;


     // si le contrat choisi ne peut tre propos alors on passe
        if (tmpcontrat<=maxic) tmpcontrat=passe;
        return tmpcontrat;
}

//---------------------------------------------------------------------------
// Procdure appele lorsque le preneur a fait son appel ( 5 joueurs)
// paramtres roi = carte(valeur de 1  78) correspondant au roi appel
void _stdcall Recoit_Appel(int roi)
{
}

//---------------------------------------------------------------------------
// fonction renvoyant le roi  appeler par le preneur ( 5 joueurs)
// valeur de retour : carte (valeur de 1  78) correspondant au roi appel
int _stdcall Envoie_Appel()
{
     // appelle un roi qui n'est pas dans la main du preneur
     for (int cnt=coeur;cnt<=trefle;cnt++)
        if (!comprend(j[preneur].main,carte2byte(cnt,roi)))
           return carte2byte(cnt,roi);
     // si on arrive ici c'est que le preneur a les 4 rois; appel du roi de coeur par dfaut.
     return carte2byte(coeur,roi);
}


//---------------------------------------------------------------------------
// procdure appele lorsque le preneur a fait son chien
// paramtres : cartes = chane de 6 (ou 3) caractres dont la valeur numrique correspond aux cartes cartes
void _stdcall Recoit_Ecart(char * cartes)
{
     // on donne au preneur les cartes du chien
        j[preneur].main+=chien;
        ecart=cartes;
     // on reprend au preneur les cartes cartes
        for (int cnt=0; cnt<ecart.size();cnt++) j[preneur].main=retire(j[preneur].main,ecart[cnt]);
}


//---------------------------------------------------------------------------
// fonction renvoyant l'cart conseill pour le joueur "joueur" (qui est preneur)
// paramtres : joueur = numro (1..5) du joueur en question (il s'agit du preneur)
char * _stdcall Envoie_Ecart(int joueur)
{
     byte val[trefle];
     string s="";
     // pour chaque couleur, on compte le nombre de cartes en main
     for (int cnt=coeur;cnt<=trefle;cnt++)
     {
          val[cnt]=0;
          for (int cnt2=1; cnt2<=dam; cnt2++)
            if (comprend(j[joueur].main,carte2byte(cnt,cnt2))) val[cnt]++;
     }
     // nombre de cartes  carter ? (3  5 joueurs sinon 6 cartes)
     int x=(NbJ==5 ? 3 : 6);

     // on essaye d'carter toute une couleur, de prfrence la plus longue (c'est dbile mais c'est un exemple !!!)
     for (int cnt=x; cnt>=1; cnt--)
       for (int cnt2=coeur;cnt2<=trefle;cnt2++)
          for (int cnt3=dam; cnt3>=1; cnt3--)
              if (comprend(j[joueur].main,carte2byte(cnt2,cnt3)) && s.size()<x) s+=carte2byte(cnt2,cnt3);
     if (s.size()<x)
        for (int cnt=coeur;cnt<=trefle;cnt++)
          for (int cnt2=1;cnt2<=dam; cnt2++)
              if (comprend(j[joueur].main,carte2byte(cnt,cnt2) && !comprend(s,carte2byte(cnt,cnt2))) && s.size()<x) s+=carte2byte(cnt,cnt2);
     return s.begin();
}


//---------------------------------------------------------------------------
// procdure appele lorsqu'un joueur dclare une poigne
// paramtres : joueur = numro (1..5) du joueur en question
//              cartes = chane contenant les atouts montrs dans la poigne
void _stdcall Recoit_Poignee(int joueur, char * cartes)
{
}


//---------------------------------------------------------------------------
// fonction renvoyant les cartes devant tre montres dans la poigne de joueur
// pour ne pas montrer de poigne, renvoyer ''
char * _stdcall Envoie_Poignee(int joueur)
{
        return "";       // on ne dclare pas de poigne !
}


//---------------------------------------------------------------------------
// procdure appele  chaque carte joue
// paramtres : joueur = joueur (1..5) qui vient de jouer
//              carte = numro de la carte joue par le joueur
//              meneur = numro (1..5) du joueur matre aprs la jouerie du joueur
void _stdcall Recoit_Jouerie(int joueur,int carte,int meneur)
{
        pli[joueur]=carte;
        j[joueur].main=retire(j[joueur].main,carte);
        maitre=meneur;
}

//---------------------------------------------------------------------------
// fonction renvoyant le conseil de joueur pour le joueur "joueur"
// paramtres : joueur = numro du joueur (1..5) dont on tudie la jouerie (c'est forcment le joueur qui a la main)
int _stdcall Envoie_Jouerie(int joueur)
{

     // on tire une carte au hasard (1..78) jusqu' ce que celle-ci appartienne au joueur et puisse tre joue
     // (appel de px, qui est en fait la fonction "peutjouer" de Webtarot, laquelle renvoit true si la carte
     // peut tre joue en fonction des rgles du tarot, et false si elle ne le peut pas
     int cnt;
     do cnt=rand() % 78+1; while (! (comprend(j[joueur].main,cnt)&& px(joueur,cnt) ));
     return cnt;
}

//---------------------------------------------------------------------------
// procdure appele en fin de partie (que la partie se termine normalement ou qu'elle soit interrompue)
// utiliser cette procdure pour librer d'ventuelles variables alloues dynamiquement
void _stdcall Fin_Partie()
{
}

