library dummydll;

{
  ****************************************************************
  Auteur : panurge (panurge@taroteam.com)
  Version : 0.1 (12 fvrier 2002)
  Remarque : Exemple d'IA pour WebTarot utilisant l'API adquate.
             vous allez voir, elle est vraiment bte, cette IA !!!
  ****************************************************************
}

{$R *.RES}
uses sysutils; // je ne sais pas pourquoi mais sans cette rfrence la routine d'cart plante...

// on se cre quelques types histoire de se simplifier la vie
type
    t_main = set of byte; // une main est un ensemble de cartes (une carte = un byte)
    t_joueur =
    record
          main : t_main; // dans cet exemple simple, un joueur n'est dfini que par sa main
    end;
    t_peutjouer= function(joueur,carte:integer):boolean;stdcall; // structure de la fonction WebTarot "peutjouer" (cf infra)
    c_type = pchar;

// constantes relatives aux valeurs numriques des cartes
const passe=0;petite=1;garde=2;gardeS=3;gardeC=4; // valeur des contrats
      coeur=1;pique=2;carreau=3;trefle=4;atout=5; // couleurs et atouts
      val=11;cav=12;dam=13;roi=14; // valeur des ttes
      excuse=78; // l'excuse est la dernire des 78 cartes !

// on se dclare une paire de variables pour ne pas perdre la mmoire :)
// libre  vous de stocker comme vous le voulez les mains, plis et autres valeurs (le stockage ici implment n'est qu'un exemple)
Var NbJ:integer; // on va stocker le nombre de joueurs
    j:array[1..5] of t_joueur; // sauvegarde de la main actuelle de chacun des joueurs
    chien,ecart:t_main; // sauvegarde du chien et de l'cart
    preneur:byte; // numro (1..5) du preneur
    contrat:byte; // contrat (passe..gardeC) du preneur
    px:t_peutjouer; // pointeur vers la fonction "peutjouer" de WebTarot (utilisable pour vrifier le respect des rgles du tarot)

    pli:array[1..5] of byte; // pli en cours (pli[1] correspond ici  la carte joue par le joueur 1)
    maitre,entame:integer; // numro (1..5) du joueur maitre du pli et du joueur entamant le pli

// renvoit le n de la carte (1..78)
function carte2byte(couleur,hauteur:byte):byte;
begin
     carte2byte:=(couleur-1)*14+hauteur;
end;


// renvoit la couleur (coeur..atout) de la carte "carte"
function couleur(carte:byte):byte;
begin
     if (carte>4*14) then couleur:=atout else couleur:=(carte-1) div 14+1;
end;

// renvoit la hauteur (1..roi ou 1..excuse) de la carte "carte"
function hauteur(carte:byte):byte;
begin
     if (carte>4*14) then hauteur:=carte-4*14 else hauteur:=(carte-1) mod 14+1;
end;


// procdure appele en dbut de partie
// paramtres : nbjoueurs = nombre de joueurs  la partie (3..5)
//              pointeur_peutjouer = pointeur vers la fonction de WebTarot "peutjouer"
procedure Debut_Partie(nbjoueurs:integer;pointeur_peutjouer:t_peutjouer);stdcall;
Var MaVal:integer;
    S:ShortString;
begin
     // rcupre le pointeur vers la fonction de WebTarot "peutjouer"
     px:=pointeur_peutjouer;
     // fixe le nombre de joueurs
     nbj:=nbjoueurs;
//     MessageBox(0,'Dbut de la partie','dummydll',0);
     // vide l'cart
     ecart:=[];
end;

// procdure appele  chaque dbut de pli
// paramtres : numpli = numro du pli en cours (1..24)
//              entameur = numro (1..5) du joueur charg d'entamer le pli
procedure Debut_Pli(numpli,entameur:integer);stdcall;
var cnt:byte;
begin
     // mise  zro du pli, du joueur matre et fixe l'entame
    for cnt:=1 to 5 do pli[cnt]:=0;
    maitre:=0;
    entame:=entameur;
end;

// procdure appele  chaque fin de pli
// paramtres : nump = numro (1..24) du pli qui vient de s'achever
procedure Fin_Pli(nump:integer);stdcall;
begin
end;

// procdure appele lors de la distribution (elle est appele nbjoueurs+1 fois)
// paramtres : joueur = numro du joueur dont on communique la main (1..5 pour joueur 1..5 et 0 pour le chien)
//              cartes = chane dont la valeur numrique de chaque caractre correspond  une carte (ex : byte('A')=65)
procedure Recoit_Distribution(joueur:integer;cartes:c_type);stdcall;
var pmain:^t_main;
    cnt:integer;
begin
     // si joueur=0 (chien) alors pointe sur le chien sinon sur la main du joueur (joueur)
     if (joueur=0) then pmain:=@chien else pmain:=@j[joueur].main;
     // remise  zro de la main concerne (chien ou main du joueur)
     pmain^:=[];
     // on remplit la main concerne avec les cartes reues (chaque caractre de la chine "cartes" est convertie
     // en byte pour retrouver le numro de la carte, laquelle est ensuite ajoute  la main)
     for cnt:=0 to length(cartes)-1 do pmain^:=pmain^+[byte(cartes[cnt])];
end;

// procdure appele  chaque fois qu'un joueur "joueur" a fait une enchre "lecontrat"
// paramtres : joueur = numro du joueur en question (1..5)
//              lecontrat = contrat pris par ce joueur (passe..gardec)
procedure Recoit_Enchere(joueur:integer;lecontrat:integer);stdcall;
begin
     // si le joueur en question passe, a ne nous intresse pas
     if (lecontrat>passe) then
     begin
          // le preneur (provisoire) et son contrat sont sauvegards
          contrat:=lecontrat;
          preneur:=joueur;
     end;
end;

// fonction renvoyant l'enchre conseille pour le joueur
// paramtres : joueur = numro du joueur en question
//              maxic  = plus haut contrat pris jusqu' prsent
function Envoie_Enchere(joueur,maxic:integer):integer;stdcall;
var tmpcontrat:byte;
begin
     // le contrat dpend du nombre de bouts en main (1-> petite, 2->garde, 3->gardesans);
     tmpcontrat:=passe;
     if (carte2byte(atout,1) in j[joueur].main) then inc(tmpcontrat);
     if (carte2byte(atout,21) in j[joueur].main) then inc(tmpcontrat);
     if (excuse in j[joueur].main) then inc(tmpcontrat);

     // si le contrat choisi ne peut tre propos alors on passe
     if (tmpcontrat<=maxic) then tmpcontrat:=0;
     Envoie_Enchere:=tmpcontrat;
end;

// Procdure appele lorsque le preneur a fait son appel ( 5 joueurs)
// paramtres roi = carte(valeur de 1  78) correspondant au roi appel
procedure Recoit_Appel(roi:integer);stdcall;
begin
end;

// fonction renvoyant le roi  appeler par le preneur ( 5 joueurs)
// valeur de retour : carte (valeur de 1  78) correspondant au roi appel
function Envoie_Appel():integer;stdcall;
var cnt:byte;
begin
     // appel un roi qui n'est pas dans la main du preneur
     for cnt:=coeur to trefle do if not carte2byte(cnt,roi) in j[preneur].main then
     begin
          Envoie_Appel:=carte2byte(cnt,roi);
          exit;
     end;
     // si on arrive ici c'est que le preneur a les 4 rois; appel du roi de coeur par dfaut.
     Envoie_Appel:=carte2byte(coeur,roi);
end;

// procdure appele lorsque le preneur a fait son chien
// paramtres : cartes = chane de 6 (ou 3) caractres dont la valeur numrique correspond aux cartes cartes
procedure Recoit_Ecart(cartes:c_type);stdcall;
var cnt:integer;
begin
     // on donne au preneur les cartes du chien
     for cnt:=1 to 78 do if cnt in chien then j[preneur].main:=j[preneur].main+[cnt];
     // on reprend au preneur les cartes cartes
     ecart:=[];
     for cnt:=0 to length(cartes)-1 do
     begin
          ecart:=ecart+[byte(cartes[cnt])]; // on met la carte  l'cart
          j[preneur].main:=j[preneur].main-[byte(cartes[cnt])]; // on l'enlve de la main du preneur
     end;

end;

// fonction renvoyant l'cart conseill pour le joueur "joueur" (qui est preneur)
// paramtres : joueur = numro (1..5) du joueur en question (il s'agit du preneur)
function Envoie_Ecart(joueur:integer):c_type;stdcall;
var cnt,x,cnt2,cnt3:byte;
    nbc:byte;
    val:array[coeur..trefle] of byte;
    s:string;
    pc:pchar;
begin
    s:='';
     // pour chaque couleur, on compte le nombre de cartes en main
     for cnt:=coeur to trefle do
     begin
          val[cnt]:=0;
          for cnt2:=1 to dam do if carte2byte(cnt,cnt2) in j[joueur].main then inc(val[cnt]);
     end;
     // nombre de cartes  carter ? (3  5 joueurs sinon 6 cartes)
     if (nbj=5) then x:=3 else x:=6;

     // on essaye d'carter toute une couleur, de prfrence la plus longue (c'est dbile mais c'est un exemple !!!)
     for cnt:=x downto 1 do
     for cnt2:=coeur to trefle do if val[cnt2]=cnt then
          for cnt3:=dam downto 1 do
              if (carte2byte(cnt2,cnt3) in j[joueur].main) and (length(s)<x) then s:=s+char(carte2byte(cnt2,cnt3));
     if (length(s)<x) then
        for cnt:=coeur to trefle do
        for cnt2:=1 to dam do
            if (carte2byte(cnt,cnt2) in j[joueur].main) and (length(s)<x) then s:=s+char(carte2byte(cnt,cnt2));

     pc:=pchar(s);
    // if (length(pc)<>x) then pc:=''; // empche le compilateur de simplifier en Envoie_Ecart:=pchar(s); (a plante)
     Envoie_Ecart:=pc;

end;

// procdure appele lorsqu'un joueur dclare une poigne
// paramtres : joueur = numro (1..5) du joueur en question
//              cartes = chane contenant les atouts montrs dans la poigne
procedure Recoit_Poignee(joueur:integer;cartes:c_type);stdcall;
begin
end;

// fonction renvoyant les cartes devant tre montres dans la poigne de joueur
// pour ne pas montrer de poigne, renvoyer ''
function Envoie_Poignee(joueur:integer):c_type;stdcall;
begin
     Envoie_Poignee:=''; // on ne dclare pas de poigne !
end;


// procdure appele  chaque carte joue
// paramtres : joueur = joueur (1..5) qui vient de jouer
//              carte = numro de la carte joue par le joueur
//              meneur = numro (1..5) du joueur matre aprs la jouerie du joueur
procedure Recoit_Jouerie(joueur,carte,meneur:integer);stdcall;
begin
     pli[joueur]:=carte;
     j[joueur].main:=j[joueur].main-[carte];
     maitre:=meneur;
end;


// fonction renvoyant le conseil de joueur pour le joueur "joueur"
// paramtres : joueur = numro du joueur (1..5) dont on tudie la jouerie (c'est forcment le joueur qui a la main)
function Envoie_Jouerie(joueur:integer):integer;stdcall;
var cnt:byte;
begin
     // on tire une carte au hasard (1..78) jusqu' ce que celle-ci appartienne au joueur et puisse tre joue
     // (appel de px, qui est en fait la fonction "peutjouer" de Webtarot, laquelle renvoit true si la carte
     // peut tre joue en fonction des rgles du tarot, et false si elle ne le peut pas
     repeat
           cnt:=random(78)+1;
     until (cnt in j[joueur].main) and (px(joueur,cnt));
     Envoie_Jouerie:=cnt;
end;

// procdure appele en fin de partie (que la partie se termine normalement ou qu'elle soit interrompue)
// utiliser cette procdure pour librer d'ventuelles variables alloues dynamiquement
procedure Fin_Partie;stdcall;
begin
end;


// exportations des routines devant (pouvant) tre utilises par WebTarot
exports Debut_Partie,
        Recoit_Distribution,
        Recoit_Enchere, Envoie_Enchere,
        Recoit_Appel, Envoie_Appel,
        Recoit_Ecart, Envoie_Ecart,
        Recoit_Poignee, Envoie_Poignee,
        Debut_Pli,Fin_Pli,
        Recoit_Jouerie, Envoie_Jouerie,
        Fin_Partie
        ;

// intialisation de la DLL (n'intervient qu'une fois, lors du chargement de la DLL)
begin
     randomize;
end.
